package writer2latex.rdf;

import java.io.IOException;
import java.io.InputStream;
import java.io.StringWriter;
import java.util.HashMap;
import java.util.Iterator;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.stream.events.Namespace;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerFactoryConfigurationError;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.apache.jena.rdf.model.Model;
import org.apache.jena.rdf.model.ModelFactory;
import org.apache.jena.rdf.model.Property;
import org.apache.jena.rdf.model.Resource;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.ls.DOMImplementationLS;
import org.w3c.dom.ls.LSSerializer;

import com.sun.org.apache.xml.internal.utils.NameSpace;

import pro.litvinovg.xml.Debug;
import writer2latex.api.ConverterResult;
import writer2latex.api.OutputFile;
import writer2latex.base.ConverterResultImpl;
import writer2latex.xhtml.Converter;
import writer2latex.xhtml.XhtmlDocument;


public final class RDFConverter extends Converter {

   // Constructor
   public RDFConverter() {
       super(XhtmlDocument.HTML5);
       this.isRDF = true;
   }

     @Override public ConverterResult convert(InputStream is, String sTargetFileName) throws IOException {
     	setOpenPubStructure(false);
     	ConverterResult xhtmlResult = super.convert(is, "chapter");
    	createPackage();


     	return createPackage(xhtmlResult,sTargetFileName);
     }
     
     @Override public ConverterResult convert(org.w3c.dom.Document dom, String sTargetFileName, boolean bDestructive) throws IOException {
     	ConverterResult xhtmlResult = super.convert(dom, "chapter", bDestructive);
     	return createPackage(xhtmlResult,sTargetFileName);    	
     }
     
  	private ConverterResult createPackage() {
  		createRDF();
  		return converterResult;
  
  	}
  
  	private void createRDF() {

  		
		/*
		 * Resource root = m.createResource(ts + "elenphArticle");
		 * 
		 * Property itemNumber = m.createProperty(ts + "itemNumber"); Property hasItem =
		 * m.createProperty(ts + "hasItem"); Property hasText = m.createProperty(ts +
		 * "hasText");
		 * 
		 * elements.put("root", root);
		 */
  		
  		DocumentStructure structure = new DocumentStructure(this.outFiles);

  		structure.createTree();
  		structure.printModel();
			/*
			 * if (elements.containsKey(path)) { element = elements.get(path); } else {
			 * element = m.createResource(ts + "Element/" + path); }
			 * element.addProperty(hasText, body.toString());
			 * 
			 * tocItem = m.createResource(ts + "TOCItem/" + path);
			 * tocItem.addProperty(itemNumber, order); String parentPath =
			 * calculateParentPath(path); System.out.println("parentPath " + parentPath);
			 * System.out.println("exPath " + path); Resource parent; if
			 * (elements.containsKey(parentPath)) { parent = elements.get(parentPath); }
			 * else { parent = m.createResource(ts + "Element/" + parentPath); }
			 * m.add(parent, hasItem, tocItem)
			 */;
  	
 /* 		Resource root = m.createResource(ts + "Element");
  		Property P = m.createProperty(ts + "TOCItem");
  		Property Q = m.createProperty(nsB + "Q");
  		Resource y = m.createResource(ts + "Excerpt");
  		Resource z = m.createResource(ts + "z");*/
  
/*  		m.add(root, P, y);
  		m.add(y, Q, z);
  		m.setNsPrefix("nsA", ts);
  		m.write(System.out, "RDF/XML-ABBREV");*/
  
  	}


		



		private ConverterResult createPackage(ConverterResult xhtmlResult, String sTargetFileName) {
     	ConverterResultImpl rdfResult = new ConverterResultImpl();
     	RDFWriter rdfWriter = new RDFWriter(xhtmlResult,sTargetFileName,3,getXhtmlConfig());
     	rdfResult.addDocument(rdfWriter);
     	rdfResult.setMetaData(xhtmlResult.getMetaData());
     	return rdfResult;
     }

 }